#include <stdio.h>
#include <stdlib.h>
#include <string.h>





static unsigned int get_word(unsigned char *p){
	unsigned int t;
	t = p[1];
	t = ((t << 8) | p[0]);
	return t;
}

static unsigned long get_dword(unsigned char *p){
	unsigned long t;
	t = p[3];
	t = ((t << 8) | p[2]);
	t = ((t << 8) | p[1]);
	t = ((t << 8) | p[0]);
	return t;
}




static int compare(const int *x, const int *y){
	return ((*x) - (*y));
}



int main(int argc, char *argv[]){
	FILE *fi;
	unsigned char *tbl;
	long size;
	long ofs;
	int k;
	int num;
	int ofs_tbl[256];

	if(2 > argc){
		exit(0);
	}


	fi = fopen(argv[1], "rb");
	if(NULL == fi){
		printf("t@C݂܂ (%s\n", argv[1]);
		exit(1);
	}
	fseek(fi, 0, SEEK_END);
	size = ftell(fi);
	tbl = malloc(0x1000);
	if(NULL == tbl){
		fclose(fi);
		printf("mۂł܂ł (%s\n", argv[1]);
		exit(1);
	}
	fseek(fi, 0x1400, SEEK_SET);
	fread(tbl, 1, 0x1000, fi);


	memset(ofs_tbl, 0, sizeof(ofs_tbl));
	k = 0;
	ofs = 0x10;
	while(ofs < 0x1000){
		if('\0' == tbl[ofs]){
			break;
		}
		ofs_tbl[k] = get_word(tbl + ofs + 11);
		ofs += 0x10;
		k += 1;
	}
	ofs_tbl[k] = ((size - 0x2400) / 0x400);
	num = (k + 1);
	qsort(ofs_tbl, num, sizeof(int), compare);


	k = 0;
	ofs = 0x10;
	while(ofs < 0x1000){
		void *buf;
		char *p;
		int *q;
		char t_name[16];
		long t_ofs, t_size;
		FILE *fo;

		if('\0' == tbl[ofs]){
			break;
		}
		if(0xe5 == tbl[ofs]){
			ofs += 0x10;
			k += 1;
			continue;
		}

		memset(t_name, 0, sizeof(t_name));
		memcpy(t_name, (tbl + ofs), 8);
		p = strchr(t_name, ' ');
		if(NULL != p){
			p[0] = '\0';
		}
		if(' ' != tbl[ofs + 8]){
			strcat(t_name, ".");
			strncat(t_name, (tbl + ofs + 8), 3);
			p = strchr(t_name, ' ');
			if(NULL != p){
				p[0] = '\0';
			}
		}

		t_ofs = get_word(tbl + ofs + 11);

		q = bsearch(&t_ofs, ofs_tbl, num, sizeof(int), compare);
		t_size = ((*(q + 1)) - t_ofs);

		t_ofs = (0x2400 + (t_ofs * 0x400));
		t_size = (t_size * 0x400);

		printf("%d: %-12s (%x %x\n", k, t_name, t_ofs, t_size);

		buf = malloc(t_size);
		if(NULL == buf){
			free(tbl);
			fclose(fi);
			printf("mۂł܂ł (%s\n", argv[1]);
			exit(1);
		}
		fseek(fi, t_ofs, SEEK_SET);
		fread(buf, 1, t_size, fi);

		fo = fopen(t_name, "wb");
		fwrite(buf, 1, t_size, fo);
		fclose(fo);

		free(buf);

		ofs += 0x10;
		k += 1;
	}

	free(tbl);
	fclose(fi);

	exit(0);
}
